# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 15
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from isilon_sdk.v9_4_0.models.node_status_powersupplies_node_supply import NodeStatusPowersuppliesNodeSupply  # noqa: F401,E501


class NodeStatusNodePowersupplies(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'count': 'int',
        'failures': 'int',
        'status': 'str',
        'supplies': 'list[NodeStatusPowersuppliesNodeSupply]'
    }

    attribute_map = {
        'count': 'count',
        'failures': 'failures',
        'status': 'status',
        'supplies': 'supplies'
    }

    def __init__(self, count=None, failures=None, status=None, supplies=None):  # noqa: E501
        """NodeStatusNodePowersupplies - a model defined in Swagger"""  # noqa: E501

        self._count = None
        self._failures = None
        self._status = None
        self._supplies = None
        self.discriminator = None

        if count is not None:
            self.count = count
        if failures is not None:
            self.failures = failures
        if status is not None:
            self.status = status
        if supplies is not None:
            self.supplies = supplies

    @property
    def count(self):
        """Gets the count of this NodeStatusNodePowersupplies.  # noqa: E501

        Count of how many power supplies are supported.  # noqa: E501

        :return: The count of this NodeStatusNodePowersupplies.  # noqa: E501
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this NodeStatusNodePowersupplies.

        Count of how many power supplies are supported.  # noqa: E501

        :param count: The count of this NodeStatusNodePowersupplies.  # noqa: E501
        :type: int
        """
        if count is not None and count > 9223372036854775807:  # noqa: E501
            raise ValueError("Invalid value for `count`, must be a value less than or equal to `9223372036854775807`")  # noqa: E501
        if count is not None and count < 0:  # noqa: E501
            raise ValueError("Invalid value for `count`, must be a value greater than or equal to `0`")  # noqa: E501

        self._count = count

    @property
    def failures(self):
        """Gets the failures of this NodeStatusNodePowersupplies.  # noqa: E501

        Count of how many power supplies have failed.  # noqa: E501

        :return: The failures of this NodeStatusNodePowersupplies.  # noqa: E501
        :rtype: int
        """
        return self._failures

    @failures.setter
    def failures(self, failures):
        """Sets the failures of this NodeStatusNodePowersupplies.

        Count of how many power supplies have failed.  # noqa: E501

        :param failures: The failures of this NodeStatusNodePowersupplies.  # noqa: E501
        :type: int
        """
        if failures is not None and failures > 9223372036854775807:  # noqa: E501
            raise ValueError("Invalid value for `failures`, must be a value less than or equal to `9223372036854775807`")  # noqa: E501
        if failures is not None and failures < 0:  # noqa: E501
            raise ValueError("Invalid value for `failures`, must be a value greater than or equal to `0`")  # noqa: E501

        self._failures = failures

    @property
    def status(self):
        """Gets the status of this NodeStatusNodePowersupplies.  # noqa: E501

        A descriptive status string for this node's power supplies.  # noqa: E501

        :return: The status of this NodeStatusNodePowersupplies.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this NodeStatusNodePowersupplies.

        A descriptive status string for this node's power supplies.  # noqa: E501

        :param status: The status of this NodeStatusNodePowersupplies.  # noqa: E501
        :type: str
        """
        if status is not None and len(status) > 255:
            raise ValueError("Invalid value for `status`, length must be less than or equal to `255`")  # noqa: E501
        if status is not None and len(status) < 0:
            raise ValueError("Invalid value for `status`, length must be greater than or equal to `0`")  # noqa: E501

        self._status = status

    @property
    def supplies(self):
        """Gets the supplies of this NodeStatusNodePowersupplies.  # noqa: E501

        List of this node's power supplies.  # noqa: E501

        :return: The supplies of this NodeStatusNodePowersupplies.  # noqa: E501
        :rtype: list[NodeStatusPowersuppliesNodeSupply]
        """
        return self._supplies

    @supplies.setter
    def supplies(self, supplies):
        """Sets the supplies of this NodeStatusNodePowersupplies.

        List of this node's power supplies.  # noqa: E501

        :param supplies: The supplies of this NodeStatusNodePowersupplies.  # noqa: E501
        :type: list[NodeStatusPowersuppliesNodeSupply]
        """

        self._supplies = supplies

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodeStatusNodePowersupplies):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
