# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 16
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from isilon_sdk.v9_5_0.models.healthcheck_definition_file import HealthcheckDefinitionFile  # noqa: F401,E501
from isilon_sdk.v9_5_0.models.healthcheck_definition_service import HealthcheckDefinitionService  # noqa: F401,E501


class HealthcheckDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'comment': 'str',
        'conflicts': 'list[str]',
        'dependencies': 'list[str]',
        'description': 'str',
        'files': 'list[HealthcheckDefinitionFile]',
        'id': 'str',
        'name': 'str',
        'nodes': 'list[int]',
        'services': 'list[HealthcheckDefinitionService]',
        'status': 'str'
    }

    attribute_map = {
        'comment': 'comment',
        'conflicts': 'conflicts',
        'dependencies': 'dependencies',
        'description': 'description',
        'files': 'files',
        'id': 'id',
        'name': 'name',
        'nodes': 'nodes',
        'services': 'services',
        'status': 'status'
    }

    def __init__(self, comment=None, conflicts=None, dependencies=None, description=None, files=None, id=None, name=None, nodes=None, services=None, status=None):  # noqa: E501
        """HealthcheckDefinition - a model defined in Swagger"""  # noqa: E501

        self._comment = None
        self._conflicts = None
        self._dependencies = None
        self._description = None
        self._files = None
        self._id = None
        self._name = None
        self._nodes = None
        self._services = None
        self._status = None
        self.discriminator = None

        if comment is not None:
            self.comment = comment
        if conflicts is not None:
            self.conflicts = conflicts
        if dependencies is not None:
            self.dependencies = dependencies
        if description is not None:
            self.description = description
        if files is not None:
            self.files = files
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if nodes is not None:
            self.nodes = nodes
        if services is not None:
            self.services = services
        if status is not None:
            self.status = status

    @property
    def comment(self):
        """Gets the comment of this HealthcheckDefinition.  # noqa: E501

        A long comment about the definition.  # noqa: E501

        :return: The comment of this HealthcheckDefinition.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this HealthcheckDefinition.

        A long comment about the definition.  # noqa: E501

        :param comment: The comment of this HealthcheckDefinition.  # noqa: E501
        :type: str
        """
        if comment is not None and len(comment) > 8192:
            raise ValueError("Invalid value for `comment`, length must be less than or equal to `8192`")  # noqa: E501
        if comment is not None and len(comment) < 0:
            raise ValueError("Invalid value for `comment`, length must be greater than or equal to `0`")  # noqa: E501

        self._comment = comment

    @property
    def conflicts(self):
        """Gets the conflicts of this HealthcheckDefinition.  # noqa: E501

        Other definitions that this definition conflicts with.  # noqa: E501

        :return: The conflicts of this HealthcheckDefinition.  # noqa: E501
        :rtype: list[str]
        """
        return self._conflicts

    @conflicts.setter
    def conflicts(self, conflicts):
        """Sets the conflicts of this HealthcheckDefinition.

        Other definitions that this definition conflicts with.  # noqa: E501

        :param conflicts: The conflicts of this HealthcheckDefinition.  # noqa: E501
        :type: list[str]
        """

        self._conflicts = conflicts

    @property
    def dependencies(self):
        """Gets the dependencies of this HealthcheckDefinition.  # noqa: E501

        Other definitions that this definition depends on.  # noqa: E501

        :return: The dependencies of this HealthcheckDefinition.  # noqa: E501
        :rtype: list[str]
        """
        return self._dependencies

    @dependencies.setter
    def dependencies(self, dependencies):
        """Sets the dependencies of this HealthcheckDefinition.

        Other definitions that this definition depends on.  # noqa: E501

        :param dependencies: The dependencies of this HealthcheckDefinition.  # noqa: E501
        :type: list[str]
        """

        self._dependencies = dependencies

    @property
    def description(self):
        """Gets the description of this HealthcheckDefinition.  # noqa: E501

        A short description of the definition.  # noqa: E501

        :return: The description of this HealthcheckDefinition.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this HealthcheckDefinition.

        A short description of the definition.  # noqa: E501

        :param description: The description of this HealthcheckDefinition.  # noqa: E501
        :type: str
        """
        if description is not None and len(description) > 255:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `255`")  # noqa: E501
        if description is not None and len(description) < 0:
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501

        self._description = description

    @property
    def files(self):
        """Gets the files of this HealthcheckDefinition.  # noqa: E501

        The files contained in this definition.  # noqa: E501

        :return: The files of this HealthcheckDefinition.  # noqa: E501
        :rtype: list[HealthcheckDefinitionFile]
        """
        return self._files

    @files.setter
    def files(self, files):
        """Sets the files of this HealthcheckDefinition.

        The files contained in this definition.  # noqa: E501

        :param files: The files of this HealthcheckDefinition.  # noqa: E501
        :type: list[HealthcheckDefinitionFile]
        """

        self._files = files

    @property
    def id(self):
        """Gets the id of this HealthcheckDefinition.  # noqa: E501

        A unique identifier for the definition.  # noqa: E501

        :return: The id of this HealthcheckDefinition.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this HealthcheckDefinition.

        A unique identifier for the definition.  # noqa: E501

        :param id: The id of this HealthcheckDefinition.  # noqa: E501
        :type: str
        """
        if id is not None and len(id) > 255:
            raise ValueError("Invalid value for `id`, length must be less than or equal to `255`")  # noqa: E501
        if id is not None and len(id) < 0:
            raise ValueError("Invalid value for `id`, length must be greater than or equal to `0`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this HealthcheckDefinition.  # noqa: E501

        The name of the definition.  # noqa: E501

        :return: The name of this HealthcheckDefinition.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this HealthcheckDefinition.

        The name of the definition.  # noqa: E501

        :param name: The name of this HealthcheckDefinition.  # noqa: E501
        :type: str
        """
        if name is not None and len(name) > 255:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `255`")  # noqa: E501
        if name is not None and len(name) < 0:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `0`")  # noqa: E501

        self._name = name

    @property
    def nodes(self):
        """Gets the nodes of this HealthcheckDefinition.  # noqa: E501

        The nodes that this definition is installed on.  # noqa: E501

        :return: The nodes of this HealthcheckDefinition.  # noqa: E501
        :rtype: list[int]
        """
        return self._nodes

    @nodes.setter
    def nodes(self, nodes):
        """Sets the nodes of this HealthcheckDefinition.

        The nodes that this definition is installed on.  # noqa: E501

        :param nodes: The nodes of this HealthcheckDefinition.  # noqa: E501
        :type: list[int]
        """

        self._nodes = nodes

    @property
    def services(self):
        """Gets the services of this HealthcheckDefinition.  # noqa: E501

        The services affected during the definition deployment  # noqa: E501

        :return: The services of this HealthcheckDefinition.  # noqa: E501
        :rtype: list[HealthcheckDefinitionService]
        """
        return self._services

    @services.setter
    def services(self, services):
        """Sets the services of this HealthcheckDefinition.

        The services affected during the definition deployment  # noqa: E501

        :param services: The services of this HealthcheckDefinition.  # noqa: E501
        :type: list[HealthcheckDefinitionService]
        """

        self._services = services

    @property
    def status(self):
        """Gets the status of this HealthcheckDefinition.  # noqa: E501

        The installation status of this definition on the cluster.  # noqa: E501

        :return: The status of this HealthcheckDefinition.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this HealthcheckDefinition.

        The installation status of this definition on the cluster.  # noqa: E501

        :param status: The status of this HealthcheckDefinition.  # noqa: E501
        :type: str
        """
        if status is not None and len(status) > 255:
            raise ValueError("Invalid value for `status`, length must be less than or equal to `255`")  # noqa: E501
        if status is not None and len(status) < 0:
            raise ValueError("Invalid value for `status`, length must be greater than or equal to `0`")  # noqa: E501

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HealthcheckDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
