# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 16
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SessionsInvalidation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'expiration': 'int',
        'not_before': 'int'
    }

    attribute_map = {
        'expiration': 'expiration',
        'not_before': 'not_before'
    }

    def __init__(self, expiration=None, not_before=None):  # noqa: E501
        """SessionsInvalidation - a model defined in Swagger"""  # noqa: E501

        self._expiration = None
        self._not_before = None
        self.discriminator = None

        if expiration is not None:
            self.expiration = expiration
        if not_before is not None:
            self.not_before = not_before

    @property
    def expiration(self):
        """Gets the expiration of this SessionsInvalidation.  # noqa: E501

        The time in seconds since the UNIX epoch when this invalidation expires.  # noqa: E501

        :return: The expiration of this SessionsInvalidation.  # noqa: E501
        :rtype: int
        """
        return self._expiration

    @expiration.setter
    def expiration(self, expiration):
        """Sets the expiration of this SessionsInvalidation.

        The time in seconds since the UNIX epoch when this invalidation expires.  # noqa: E501

        :param expiration: The expiration of this SessionsInvalidation.  # noqa: E501
        :type: int
        """
        if expiration is not None and expiration > 4294967295:  # noqa: E501
            raise ValueError("Invalid value for `expiration`, must be a value less than or equal to `4294967295`")  # noqa: E501
        if expiration is not None and expiration < 0:  # noqa: E501
            raise ValueError("Invalid value for `expiration`, must be a value greater than or equal to `0`")  # noqa: E501

        self._expiration = expiration

    @property
    def not_before(self):
        """Gets the not_before of this SessionsInvalidation.  # noqa: E501

        The time in seconds since the UNIX epoch, before which sessions for a user are disallowed.  # noqa: E501

        :return: The not_before of this SessionsInvalidation.  # noqa: E501
        :rtype: int
        """
        return self._not_before

    @not_before.setter
    def not_before(self, not_before):
        """Sets the not_before of this SessionsInvalidation.

        The time in seconds since the UNIX epoch, before which sessions for a user are disallowed.  # noqa: E501

        :param not_before: The not_before of this SessionsInvalidation.  # noqa: E501
        :type: int
        """
        if not_before is not None and not_before > 4294967295:  # noqa: E501
            raise ValueError("Invalid value for `not_before`, must be a value less than or equal to `4294967295`")  # noqa: E501
        if not_before is not None and not_before < 0:  # noqa: E501
            raise ValueError("Invalid value for `not_before`, must be a value greater than or equal to `0`")  # noqa: E501

        self._not_before = not_before

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SessionsInvalidation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
