# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 16
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from isilon_sdk.v9_5_0.models.supportassist_data_item_data import SupportassistDataItemData  # noqa: F401,E501


class SupportassistDataItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contract_version': 'str',
        'data': 'SupportassistDataItemData',
        'payload_type': 'str',
        'payload_version': 'str'
    }

    attribute_map = {
        'contract_version': 'contractVersion',
        'data': 'data',
        'payload_type': 'payloadType',
        'payload_version': 'payloadVersion'
    }

    def __init__(self, contract_version=None, data=None, payload_type=None, payload_version='1.0'):  # noqa: E501
        """SupportassistDataItem - a model defined in Swagger"""  # noqa: E501

        self._contract_version = None
        self._data = None
        self._payload_type = None
        self._payload_version = None
        self.discriminator = None

        if contract_version is not None:
            self.contract_version = contract_version
        if data is not None:
            self.data = data
        self.payload_type = payload_type
        self.payload_version = payload_version

    @property
    def contract_version(self):
        """Gets the contract_version of this SupportassistDataItem.  # noqa: E501

        Contract Version.  # noqa: E501

        :return: The contract_version of this SupportassistDataItem.  # noqa: E501
        :rtype: str
        """
        return self._contract_version

    @contract_version.setter
    def contract_version(self, contract_version):
        """Sets the contract_version of this SupportassistDataItem.

        Contract Version.  # noqa: E501

        :param contract_version: The contract_version of this SupportassistDataItem.  # noqa: E501
        :type: str
        """
        if contract_version is not None and len(contract_version) > 255:
            raise ValueError("Invalid value for `contract_version`, length must be less than or equal to `255`")  # noqa: E501
        if contract_version is not None and len(contract_version) < 1:
            raise ValueError("Invalid value for `contract_version`, length must be greater than or equal to `1`")  # noqa: E501

        self._contract_version = contract_version

    @property
    def data(self):
        """Gets the data of this SupportassistDataItem.  # noqa: E501

          # noqa: E501

        :return: The data of this SupportassistDataItem.  # noqa: E501
        :rtype: SupportassistDataItemData
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this SupportassistDataItem.

          # noqa: E501

        :param data: The data of this SupportassistDataItem.  # noqa: E501
        :type: SupportassistDataItemData
        """

        self._data = data

    @property
    def payload_type(self):
        """Gets the payload_type of this SupportassistDataItem.  # noqa: E501

        Type of payload request.  # noqa: E501

        :return: The payload_type of this SupportassistDataItem.  # noqa: E501
        :rtype: str
        """
        return self._payload_type

    @payload_type.setter
    def payload_type(self, payload_type):
        """Sets the payload_type of this SupportassistDataItem.

        Type of payload request.  # noqa: E501

        :param payload_type: The payload_type of this SupportassistDataItem.  # noqa: E501
        :type: str
        """
        if payload_type is None:
            raise ValueError("Invalid value for `payload_type`, must not be `None`")  # noqa: E501
        if payload_type is not None and len(payload_type) > 255:
            raise ValueError("Invalid value for `payload_type`, length must be less than or equal to `255`")  # noqa: E501

        self._payload_type = payload_type

    @property
    def payload_version(self):
        """Gets the payload_version of this SupportassistDataItem.  # noqa: E501

        Payload version.  # noqa: E501

        :return: The payload_version of this SupportassistDataItem.  # noqa: E501
        :rtype: str
        """
        return self._payload_version

    @payload_version.setter
    def payload_version(self, payload_version):
        """Sets the payload_version of this SupportassistDataItem.

        Payload version.  # noqa: E501

        :param payload_version: The payload_version of this SupportassistDataItem.  # noqa: E501
        :type: str
        """
        if payload_version is None:
            raise ValueError("Invalid value for `payload_version`, must not be `None`")  # noqa: E501
        if payload_version is not None and len(payload_version) > 255:
            raise ValueError("Invalid value for `payload_version`, length must be less than or equal to `255`")  # noqa: E501
        if payload_version is not None and len(payload_version) < 1:
            raise ValueError("Invalid value for `payload_version`, length must be greater than or equal to `1`")  # noqa: E501

        self._payload_version = payload_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupportassistDataItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
